//Dixon’s Factorization method by 'chitranayal' from Geek for Geeks
//This is cracker code for Congruence of Squares
//But seems to lack the summation of exponents. ie  2940 = 2^2 * 3 * 5 * 7^2
//Which would be rewitten as {2,0,0,2} ie a set of Powers !
//Theoretically this could be determined with int Tal_2s[]{ 2,2,2,4,2,4,2 };
//So each square determined by int base[8] = { 1,3,5,7,11,13,17,19 }; with a Prime Gap: Tal_2s
//I have included a Prime Generator and GCD as a Factor Base
//But as I require a way of determining 1(mod 8) for the PQa LMM. I like the code !
//As a Congruence of Squares !

#include <algorithm>
#include <cmath>
#include <iostream>
#include <set>
#include <vector>

using namespace std;

typedef unsigned long long int Mi5;
//template <typename NumberContainer>  pointer

Mi5 gcd(Mi5 a, Mi5 b) {
    if (b == 0)
        return a;
    else
        return gcd(b, a % b);
}
template <typename NumberContainer>
void removeTheNumbers(NumberContainer& Primeans, Mi5 Pristart)  //it is correct to use remove_if() here
{
    for (auto iter{ Primeans.begin() }; iter != Primeans.end(); )
    {
        if (*iter < Pristart)
        {
            iter = Primeans.erase(iter);
        }
        else  
        {
            ++iter;
        }
    }
}

vector<Mi5> Prisieve(Mi5 n, Mi5 Pristart)
{
    vector<bool> prime(n + 1, true);

    prime[0] = false;
    prime[1] = false;
    int m = sqrt(n);
    int NumberPrimes1 = 0;

    for (Mi5 p = 2; p <= m; p++)
    {
        // If prime[p] is not changed, then it
        // be a prime worth including
        if (prime[p])
        {
            // Update all multiples of p
            for (Mi5 i = p * 2; i <= n; i += p)
                prime[i] = false;
        }
    }
    // push all the primes into the vector 
    vector<Mi5> Primeans;
    for (int i = 0; i < n; i++)
        if (prime[i]) {
            Primeans.push_back(i);
        }
    removeTheNumbers(Primeans, Pristart);
    for (auto ip : Primeans) {
        NumberPrimes1 += 1;
    }
    cout << "NumberPrimes1 =" << NumberPrimes1 << endl;
    return Primeans;
}

void Mod_Congruence_of_Squares1(int n)
{
    //Code Block if chosing Factor Base//
    //For example try 78654 = factor doesn't include 2
//
//    Mi5 Pristart = 0; //This the start with 'n' being the end
//    vector<Mi5> Prians = Prisieve(n, Pristart); //This calls Prime Generator//
//
//     Code Block if chosing Factor Base    //
    // Factor base for the given number Mod 20 Good for number < 1000
    int base[8] = { 1,3,5,7,11,13,17,19 };  // Original int Base[4] = {2,3,5,7}
//    int Tal_2s[]{ 2,2,2,4,2,4,2 };  //This I included for Prime Gaps
    //For example in counting how many '2's in 78654 //-1( Z^2 mod n)?
    // Ro_Top is ceiling
    int Ro_Top = int(sqrt(n));
    // Storing the related squares
    vector<vector<int> >pairs;
    int factor_1 = 0;
    int factor_2 = 0;
    int len = sizeof(base) / sizeof(base[0]);
    for (int i = Ro_Top; i < n; i++)
    {
        vector<int> v;
        // Finding the related squares
        for (int j = 0; j < len; j++)
        {
            int lhs = ((int)pow(i, 2)) % n;  //-1( Z^2 mod n)?
            int rhs = ((int)pow(base[j], 2)) % n;  // Z^2 mod n
            // If the two numbers are the
            // related squares, then append
            // them to the array
            if (lhs == rhs)
            {
                v.push_back(i);
                v.push_back(base[j]);
                pairs.push_back(v);
            }
        }
    }
    vector<int>newvacumm;
    // For every pair in the array, compute the
    // GCD such that
    len = pairs.size();
    for (int i = 0; i < len; i++) {
        int factor = gcd(pairs[i][0] - pairs[i][1], n);
        // If we find a factor other than 1, then
        // appending it to the final factor array
        if (factor != 1)
            newvacumm.push_back(factor);
        if ((factor == 1)&&(factor_1 == 0)){
            if (((n - 1) / 8) == (floor((n - 1) / 8))) {
                cout << "1 Mod 8  Prime " << factor << endl;
                factor_1 = 1;
            }
        }
        if ((factor == 1) && (factor_2 == 0)) {
            if (((n - 7) / 8) == (floor((n - 7) / 8))) {
                cout << "7 Mod 8  Prime " << factor << endl;
                factor_2 = 1;
            }
        }
    }
    set<int>s;
    for (int i = 0; i < newvacumm.size(); i++)
        s.insert(newvacumm[i]);
    for (auto i = s.begin(); i != s.end(); i++)
        cout << (*i) << " ";
}

int main() {
    int Ch_N = 0;
    cout << "Enter Number to factor = " << endl;
    cin >> Ch_N;
    Mod_Congruence_of_Squares1(Ch_N);
}
